<a id="mypy-boto3-sso-admin"></a>

# mypy-boto3-sso-admin

[![PyPI - mypy-boto3-sso-admin](https://img.shields.io/pypi/v/mypy-boto3-sso-admin.svg?color=blue)](https://pypi.org/project/mypy-boto3-sso-admin)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sso-admin.svg?color=blue)](https://pypi.org/project/mypy-boto3-sso-admin)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sso_admin/)
[![PyPI - Downloads](https://static.pepy.tech/badge/mypy-boto3-sso-admin)](https://pepy.tech/project/mypy-boto3-sso-admin)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.SSOAdmin 1.29.3](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sso-admin.html#SSOAdmin)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.20.3](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-sso-admin docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sso_admin/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sso-admin](#mypy-boto3-sso-admin)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Type definitions](#type-definitions)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SSOAdmin`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `SSOAdmin` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[sso-admin]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[sso-admin]'


# standalone installation
python -m pip install mypy-boto3-sso-admin
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-sso-admin
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[sso-admin]` in your environment:

```bash
python -m pip install 'boto3-stubs[sso-admin]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[sso-admin]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[sso-admin]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sso-admin]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[sso-admin]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[sso-admin]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[sso-admin]` in your environment:

```bash
python -m pip install 'boto3-stubs[sso-admin]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[sso-admin]` in your environment:

```bash
python -m pip install 'boto3-stubs[sso-admin]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SSOAdminClient` provides annotations for `boto3.client("sso-admin")`.

```python
from boto3.session import Session

from mypy_boto3_sso_admin import SSOAdminClient

client: SSOAdminClient = Session().client("sso-admin")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_sso_admin.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_sso_admin import SSOAdminClient
from mypy_boto3_sso_admin.paginator import (
    ListAccountAssignmentCreationStatusPaginator,
    ListAccountAssignmentDeletionStatusPaginator,
    ListAccountAssignmentsPaginator,
    ListAccountAssignmentsForPrincipalPaginator,
    ListAccountsForProvisionedPermissionSetPaginator,
    ListApplicationAccessScopesPaginator,
    ListApplicationAssignmentsPaginator,
    ListApplicationAssignmentsForPrincipalPaginator,
    ListApplicationAuthenticationMethodsPaginator,
    ListApplicationGrantsPaginator,
    ListApplicationProvidersPaginator,
    ListApplicationsPaginator,
    ListCustomerManagedPolicyReferencesInPermissionSetPaginator,
    ListInstancesPaginator,
    ListManagedPoliciesInPermissionSetPaginator,
    ListPermissionSetProvisioningStatusPaginator,
    ListPermissionSetsPaginator,
    ListPermissionSetsProvisionedToAccountPaginator,
    ListTagsForResourcePaginator,
    ListTrustedTokenIssuersPaginator,
)

client: SSOAdminClient = Session().client("sso-admin")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_account_assignment_creation_status_paginator: ListAccountAssignmentCreationStatusPaginator = (
    client.get_paginator("list_account_assignment_creation_status")
)
list_account_assignment_deletion_status_paginator: ListAccountAssignmentDeletionStatusPaginator = (
    client.get_paginator("list_account_assignment_deletion_status")
)
list_account_assignments_paginator: ListAccountAssignmentsPaginator = client.get_paginator(
    "list_account_assignments"
)
list_account_assignments_for_principal_paginator: ListAccountAssignmentsForPrincipalPaginator = (
    client.get_paginator("list_account_assignments_for_principal")
)
list_accounts_for_provisioned_permission_set_paginator: (
    ListAccountsForProvisionedPermissionSetPaginator
) = client.get_paginator("list_accounts_for_provisioned_permission_set")
list_application_access_scopes_paginator: ListApplicationAccessScopesPaginator = (
    client.get_paginator("list_application_access_scopes")
)
list_application_assignments_paginator: ListApplicationAssignmentsPaginator = client.get_paginator(
    "list_application_assignments"
)
list_application_assignments_for_principal_paginator: (
    ListApplicationAssignmentsForPrincipalPaginator
) = client.get_paginator("list_application_assignments_for_principal")
list_application_authentication_methods_paginator: ListApplicationAuthenticationMethodsPaginator = (
    client.get_paginator("list_application_authentication_methods")
)
list_application_grants_paginator: ListApplicationGrantsPaginator = client.get_paginator(
    "list_application_grants"
)
list_application_providers_paginator: ListApplicationProvidersPaginator = client.get_paginator(
    "list_application_providers"
)
list_applications_paginator: ListApplicationsPaginator = client.get_paginator("list_applications")
list_customer_managed_policy_references_in_permission_set_paginator: (
    ListCustomerManagedPolicyReferencesInPermissionSetPaginator
) = client.get_paginator("list_customer_managed_policy_references_in_permission_set")
list_instances_paginator: ListInstancesPaginator = client.get_paginator("list_instances")
list_managed_policies_in_permission_set_paginator: ListManagedPoliciesInPermissionSetPaginator = (
    client.get_paginator("list_managed_policies_in_permission_set")
)
list_permission_set_provisioning_status_paginator: ListPermissionSetProvisioningStatusPaginator = (
    client.get_paginator("list_permission_set_provisioning_status")
)
list_permission_sets_paginator: ListPermissionSetsPaginator = client.get_paginator(
    "list_permission_sets"
)
list_permission_sets_provisioned_to_account_paginator: (
    ListPermissionSetsProvisionedToAccountPaginator
) = client.get_paginator("list_permission_sets_provisioned_to_account")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator(
    "list_tags_for_resource"
)
list_trusted_token_issuers_paginator: ListTrustedTokenIssuersPaginator = client.get_paginator(
    "list_trusted_token_issuers"
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_sso_admin.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

Full list of `SSOAdmin` Literals can be found in
[docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sso_admin/literals/).

```python
from mypy_boto3_sso_admin.literals import ApplicationStatusType


def check_value(value: ApplicationStatusType) -> bool: ...
```

<a id="type-definitions"></a>

### Type definitions

`mypy_boto3_sso_admin.type_defs` module contains structures and shapes
assembled to typed dictionaries and unions for additional type checking.

Full list of `SSOAdmin` TypeDefs can be found in
[docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sso_admin/type_defs/).

```python
from mypy_boto3_sso_admin.type_defs import AccessControlAttributeValueTypeDef


def get_value() -> AccessControlAttributeValueTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-sso-admin` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_sso_admin/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
